//FILE: COMMDLG.INC
//VERSION: 1.0
(*$W44- *)
(*$W53- *)

(*$I windef.inc *)

type
	OPENFILENAME = packed record
		lStructSize : DWORD;
		hwndOwner : HWND;
		hInstance : _HINSTANCE;
		lpstrFilter : LPCSTR;
		lpstrCustomFilter : LPSTR;
		nMaxCustFilter : DWORD;
		nFilterIndex : DWORD;
		lpstrFile : LPSTR;
		nMaxFile : DWORD;
		lpstrFileTitle : LPSTR;
		nMaxFileTitle : DWORD;
		lpstrInitialDir : LPCSTR;
		lpstrTitle : LPCSTR;
		Flags : DWORD;
		nFileOffset : shortword;
		nFileExtension : shortword;
		lpstrDefExt : LPCSTR;
		lCustData : LPARAM;
		lpfnHook : PROC;
		lpTemplateName : LPCSTR;
	end;

	function GetOpenFileName(var ofn : OPENFILENAME) : BOOL;
    	external dll='comdlg32.dll' name='GetOpenFileNameA' stdcall;

	function GetSaveFileName(var sfn : OPENFILENAME) : BOOL;
    	external dll='comdlg32.dll' name='GetSaveFileNameA' stdcall;

	function GetFileTitle(lpszFile, lpszTitle : address; cbBuf : shortword) : SHORT;
    	external dll='comdlg32.dll' name='GetFileTitleA' stdcall;

const
	OFN_READONLY = $00000001;
	OFN_OVERWRITEPROMPT = $00000002;
	OFN_HIDEREADONLY = $00000004;
	OFN_NOCHANGEDIR = $00000008;
	OFN_SHOWHELP = $00000010;
	OFN_ENABLEHOOK = $00000020;
	OFN_ENABLETEMPLATE = $00000040;
	OFN_ENABLETEMPLATEHANDLE = $00000080;
	OFN_NOVALIDATE = $00000100;
	OFN_ALLOWMULTISELECT = $00000200;
	OFN_EXTENSIONDIFFERENT = $00000400;
	OFN_PATHMUSTEXIST = $00000800;
	OFN_FILEMUSTEXIST = $00001000;
	OFN_CREATEPROMPT = $00002000;
	OFN_SHAREAWARE = $00004000;
	OFN_NOREADONLYRETURN = $00008000;
	OFN_NOTESTFILECREATE = $00010000;
	OFN_NONETWORKBUTTON = $00020000;
	OFN_NOLONGNAMES = $00040000;

	OFN_EXPLORER = $00080000;
	OFN_NODEREFERENCELINKS = $00100000;
	OFN_LONGNAMES = $00200000;

	OFN_SHAREFALLTHROUGH = 2;
	OFN_SHARENOWARN = 1;
	OFN_SHAREWARN = 0;

type
	OFNOTIFYA = packed record
		hdr : HANDLE;
		lpOFN : address;
		pszFile : LPSTR;
	end;

const
	CDN_FIRST = -601;
	CDN_LAST = -699;

	CDN_INITDONE = -601;			//(CDN_FIRST - $0000)
	CDN_SELCHANGE = -602;			//(CDN_FIRST - $0001)
	CDN_FOLDERCHANGE = -603;		//(CDN_FIRST - $0002)
	CDN_SHAREVIOLATION = -604;		//(CDN_FIRST - $0003)
	CDN_HELP = -605;				//(CDN_FIRST - $0004)
	CDN_FILEOK = -606;				//(CDN_FIRST - $0005)
	CDN_TYPECHANGE = -607;			//(CDN_FIRST - $0006)

	CDM_FIRST = 1124;				//(WM_USER + 100)
	CDM_LAST = 1224;				//(WM_USER + 200)

	CDM_GETSPEC = 1124;				//(CDM_FIRST + $0000)
	CDM_GETFILEPATH = 1125;			//(CDM_FIRST + $0001)
	CDM_GETFOLDERPATH = 1126;		//(CDM_FIRST + $0002)
	CDM_GETFOLDERIDLIST = 1127;		//(CDM_FIRST + $0003)
	CDM_SETCONTROLTEXT = 1128;		//(CDM_FIRST + $0004)
	CDM_HIDECONTROL = 1129;			//(CDM_FIRST + $0005)
	CDM_SETDEFEXT = 1130;			//(CDM_FIRST + $0006)

type
	CHOOSE_COLOR = packed record
		lStructSize : DWORD;
		hwndOwner : HWND;
		hInstance : HWND;
		rgbResult : COLORREF;
		lpCustColors : address;
		Flags : DWORD;
		lCustData : LPARAM;
		lpfnHook : PROC;
		lpTemplateName : LPCSTR;
	end;

	function ChooseColor(var cc : CHOOSE_COLOR) : BOOL;
    	external dll='comdlg32.dll' name='ChooseColorA' stdcall;

const
	CC_RGBINIT = $00000001;
	CC_FULLOPEN = $00000002;
	CC_PREVENTFULLOPEN = $00000004;
	CC_SHOWHELP = $00000008;
	CC_ENABLEHOOK = $00000010;
	CC_ENABLETEMPLATE = $00000020;
	CC_ENABLETEMPLATEHANDLE = $00000040;
	CC_SOLIDCOLOR = $00000080;
	CC_ANYCOLOR = $00000100;

type
	FINDREPLACE = packed record
		lStructSize : DWORD;
		hwndOwner : HWND;
		hInstance : _HINSTANCE;
		Flags : DWORD;
		lpstrFindWhat : LPSTR;
		lpstrReplaceWith : LPSTR;
		wFindWhatLen : shortword;
		wReplaceWithLen : shortword;
		lCustData : LPARAM;
		lpTemplateName : LPCSTR;
	end;

const
	FR_DOWN = $00000001;
	FR_WHOLEWORD = $00000002;
	FR_MATCHCASE = $00000004;
	FR_FINDNEXT = $00000008;
	FR_REPLACE = $00000010;
	FR_REPLACEALL = $00000020;
	FR_DIALOGTERM = $00000040;
	FR_SHOWHELP = $00000080;
	FR_ENABLEHOOK = $00000100;
	FR_ENABLETEMPLATE = $00000200;
	FR_NOUPDOWN = $00000400;
	FR_NOMATCHCASE = $00000800;
	FR_NOWHOLEWORD = $00001000;
	FR_ENABLETEMPLATEHANDLE = $00002000;
	FR_HIDEUPDOWN = $00004000;
	FR_HIDEMATCHCASE = $00008000;
	FR_HIDEWHOLEWORD = $00010000;

	function FindText(var find : FINDREPLACE) : HWND;
    	external dll='comdlg32.dll' name='FindTextA' stdcall;
	function ReplaceText(var replace : FINDREPLACE) : HWND;
    	external dll='comdlg32.dll' name='ReplaceTextA' stdcall;

type
	CHOOSE_FONT = packed record
		lStructSize : DWORD;
		hwndOwner : HWND;
		hDC : _HDC;
		lpLogFont : address;
		iPointSize : integer;
		Flags : DWORD;
		rgbColors : COLORREF;
		lCustData : LPARAM;
		lpfnHook : PROC;
		lpTemplateName : LPCSTR;
		hInst : HINSTANCE;
		lpszStyle : LPSTR;
		nFontType : shortword;
		__MISSING_ALIGNMENT__ : shortword;
		nSizeMin : integer;
		nSizeMax : integer;
	end;

	function ChooseFont(var choose : CHOOSE_FONT) : BOOL;
    	external dll='comdlg32.dll' name='ChooseFontA' stdcall;

const
	CF_SCREENFONTS = $00000001;
	CF_PRINTERFONTS = $00000002;
	CF_BOTH = $00000003;			//(CF_SCREENFONTS OR CF_PRINTERFONTS)
	CF_SHOWHELP = $00000004;
	CF_ENABLEHOOK = $00000008;
	CF_ENABLETEMPLATE = $00000010;
	CF_ENABLETEMPLATEHANDLE = $00000020;
	CF_INITTOLOGFONTSTRUCT = $00000040;
	CF_USESTYLE = $00000080;
	CF_EFFECTS = $00000100;
	CF_APPLY = $00000200;
	CF_ANSIONLY = $00000400;
	CF_SCRIPTSONLY = CF_ANSIONLY;
	CF_NOVECTORFONTS = $00000800;
	CF_NOOEMFONTS = CF_NOVECTORFONTS;
	CF_NOSIMULATIONS = $00001000;
	CF_LIMITSIZE = $00002000;
	CF_FIXEDPITCHONLY = $00004000;
	CF_WYSIWYG = $00008000;
	CF_FORCEFONTEXIST = $00010000;
	CF_SCALABLEONLY = $00020000;
	CF_TTONLY = $00040000;
	CF_NOFACESEL = $00080000;
	CF_NOSTYLESEL = $00100000;
	CF_NOSIZESEL = $00200000;
	CF_SELECTSCRIPT = $00400000;
	CF_NOSCRIPTSEL  = $00800000;
	CF_NOVERTFONTS  = $01000000;

	SIMULATED_FONTTYPE = $8000;
	PRINTER_FONTTYPE = $4000;
	SCREEN_FONTTYPE = $2000;
	BOLD_FONTTYPE = $0100;
	ITALIC_FONTTYPE = $0200;
	REGULAR_FONTTYPE = $0400;

	WM_CHOOSEFONT_GETLOGFONT = $0401;		//(WM_USER + 1)

	CD_LBSELNOITEMS = -1;
	CD_LBSELCHANGE = 0;
	CD_LBSELSUB = 1;
	CD_LBSELADD = 2;

type
	PRINT_DLG = packed record
		lStructSize : DWORD;
		hwndOwner : HWND;
		hDevMode : HGLOBAL;
		hDevNames : HGLOBAL;
		hDC : _HDC;
		Flags : DWORD;
		nFromPage : shortword;
		nToPage : shortword;
		nMinPage : shortword;
		nMaxPage : shortword;
		nCopies : shortword;
		hInstance : _HINSTANCE;
		lCustData : LPARAM;
		lpfnPrintHook : PROC;
		lpfnSetupHook : PROC;
		lpPrintTemplateName : LPCSTR;
		lpSetupTemplateName : LPCSTR;
		hPrintTemplate : HGLOBAL;
		hSetupTemplate : HGLOBAL;
	end;

	function PrintDlg(var prndlg : PRINT_DLG) : BOOL;
    	external dll='comdlg32.dll' name='PrintDlgA' stdcall;

const
	PD_ALLPAGES = $00000000;
	PD_SELECTION = $00000001;
	PD_PAGENUMS = $00000002;
	PD_NOSELECTION = $00000004;
	PD_NOPAGENUMS = $00000008;
	PD_COLLATE = $00000010;
	PD_PRINTTOFILE = $00000020;
	PD_PRINTSETUP = $00000040;
	PD_NOWARNING = $00000080;
	PD_RETURNDC = $00000100;
	PD_RETURNIC = $00000200;
	PD_RETURNDEFAULT = $00000400;
	PD_SHOWHELP = $00000800;
	PD_ENABLEPRINTHOOK = $00001000;
	PD_ENABLESETUPHOOK = $00002000;
	PD_ENABLEPRINTTEMPLATE = $00004000;
	PD_ENABLESETUPTEMPLATE = $00008000;
	PD_ENABLEPRINTTEMPLATEHANDLE = $00010000;
	PD_ENABLESETUPTEMPLATEHANDLE = $00020000;
	PD_USEDEVMODECOPIES = $00040000;
	PD_USEDEVMODECOPIESANDCOLLATE = $00040000;
	PD_DISABLEPRINTTOFILE = $00080000;
	PD_HIDEPRINTTOFILE = $00100000;
	PD_NONETWORKBUTTON = $00200000;

type
	DEVNAMES = packed record
		wDriverOffset : shortword;
		wDeviceOffset : shortword;
		wOutputOffset : shortword;
		wDefault : shortword;
	end;

const
	DN_DEFAULTPRN = $0001;

	function CommDlgExtendedError : DWORD;
    	external dll='comdlg32.dll' name='CommDlgExtendedError' stdcall;

const
	WM_PSD_PAGESETUPDLG = $0400;	//(WM_USER  )
	WM_PSD_FULLPAGERECT = $0401;	//(WM_USER+1)
	WM_PSD_MINMARGINRECT = $0402;	//(WM_USER+2)
	WM_PSD_MARGINRECT = $0403;		//(WM_USER+3)
	WM_PSD_GREEKTEXTRECT = $404;	//(WM_USER+4)
	WM_PSD_ENVSTAMPRECT = $0405;	//(WM_USER+5)
	WM_PSD_YAFULLPAGERECT = $0406;	//(WM_USER+6)

type
	PAGESETUP_DLG = packed record
		lStructSize : DWORD;
		hwndOwner : HWND;
		hDevMode : HGLOBAL;
		hDevNames : HGLOBAL;
		Flags : DWORD;
		ptPaperSize : POINT;
		rtMinMargin : RECT;
		rtMargin : RECT;
		hInstance : _HINSTANCE;
		lCustData : LPARAM;
		lpfnPageSetupHook : PROC;
		lpfnPagePaintHook : PROC;
		lpPageSetupTemplateName : LPCSTR;
		hPageSetupTemplate : HGLOBAL;
	end;

	function PageSetupDlg(var psd : PAGESETUP_DLG) : BOOL;
    	external dll='comdlg32.dll' name='PrintSetupDlgA' stdcall;

const
	PSD_DEFAULTMINMARGINS = $00000000;
	PSD_INWININIINTLMEASURE = $00000000;

	PSD_MINMARGINS = $00000001;
	PSD_MARGINS = $00000002;
	PSD_INTHOUSANDTHSOFINCHES = $00000004;
	PSD_INHUNDREDTHSOFMILLIMETERS = $00000008;
	PSD_DISABLEMARGINS = $00000010;
	PSD_DISABLEPRINTER = $00000020;
	PSD_NOWARNING = $00000080;
	PSD_DISABLEORIENTATION = $00000100;
	PSD_RETURNDEFAULT = $00000400;
	PSD_DISABLEPAPER = $00000200;
	PSD_SHOWHELP = $00000800;
	PSD_ENABLEPAGESETUPHOOK = $00002000;
	PSD_ENABLEPAGESETUPTEMPLATE = $00008000;
	PSD_ENABLEPAGESETUPTEMPLATEHANDLE = $00020000;
	PSD_ENABLEPAGEPAINTHOOK = $00040000;
	PSD_DISABLEPAGEPAINTING = $00080000;
	PSD_NONETWORKBUTTON = $00200000;

(*$W53. *)
(*$W44. *)
